//+------------------------------------------------------------------+
//|                                                    Ilan1.4_k.mq4 |   Ilan1.4.mq4:
//|                                      Copyright  2008, komposter | copyright "2008 Nikisaki@yandex.ru"
//|                                      mailto:komposterius@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, komposter"
#property link      "mailto:komposterius@mail.ru"

//----   (    ) -     
extern string 		Expert_Properties 			= "-------Expert-Properties-------";
extern int 			Expert_Id 						= 2292;	//   .   2-         2 ,     Expert_Id
extern int			TradeDirection					= 0;		//   : 0 - Buy & Sell, 1 - Buy Only, -1 - Sell Only
extern int			PipStep							= 30;		//  
extern int			TakeProfit						= 10;		//     
extern double		StartLot							= 0.1;	//  
extern double		LotExponent						= 1.667;	//   
extern int			MaxTrades						= 10;		//  - 
extern int			LastStopLoss					= 30;		//      LastStopLoss    

#include <trade_lib&info_lib.mqh>

int init()
{
	TradeInfoLib_Initialization ( Expert_Id, "Ilan1.4_k" );
	return(0);
}

int deinit()
{
	TradeInfoLib_Deinitialization();
	return(0);
}

int start()
{
	if ( !IsOK() ) { return(0); }

	int _GetLastError, _OrdersTotal = OrdersTotal();

	double l, op;
	double max_lot_b = 0.0, level_b = 0.0, summ_lot_b = 0.0, ave_price_b = 0.0; int count_b = 0; static int last_b = 0;
	double max_lot_s = 0.0, level_s = 0.0, summ_lot_s = 0.0, ave_price_s = 0.0; int count_s = 0; static int last_s = 0;

	for ( int z = _OrdersTotal - 1; z >= 0; z -- )
	{
		if ( !OrderSelect( z, SELECT_BY_POS, MODE_TRADES ) )
		{
			_GetLastError = GetLastError();
			Print( "OrderSelect( ", z, ", SELECT_BY_POS, MODE_TRADES ) - Error #", _GetLastError );
			continue;
		}
		if ( OrderMagicNumber() != _MagicNumber || OrderSymbol() != _Symbol ) continue;

		l = OrderLots();
		op = OrderOpenPrice();

		if ( OrderType() == OP_BUY )
		{
			count_b ++;
			summ_lot_b += l;
			ave_price_b += op*l;
			if ( l > max_lot_b )
			{
				max_lot_b = l;
				level_b = op;
			}
		}

		if ( OrderType() == OP_SELL )
		{
			count_s ++;
			summ_lot_s += l;
			ave_price_s += op*l;
			if ( l > max_lot_s )
			{
				max_lot_s = l;
				level_s = op;
			}
		}
	}

	// check fo close
	if ( max_lot_b > 0.0 )
	{
		ave_price_b = NormalizeDouble( ave_price_b/summ_lot_b, _Digits );
		if ( NormalizeDouble( Bid - ave_price_b - TakeProfit*_Point, _Digits ) >= 0.0 )
		{
			if ( !CloseAll( OP_BUY ) ) return(-1);
			max_lot_b = 0.0;
		}
		if ( LastStopLoss > 0 && count_b >= MaxTrades )
		{
			if ( NormalizeDouble( level_b - Bid - LastStopLoss*_Point, _Digits ) >= 0.0 )
			{
				Print( "LastStopLoss for BUY!" );
				if ( !CloseAll( OP_BUY ) ) return(-1);
				max_lot_b = 0.0;
			}
		}
	}
	if ( max_lot_s > 0.0 )
	{
		ave_price_s = NormalizeDouble( ave_price_s/summ_lot_s, _Digits );
		if ( NormalizeDouble( ave_price_s - Ask - TakeProfit*_Point, _Digits ) >= 0.0 )
		{
			if ( !CloseAll( OP_SELL ) ) return(-1);
			max_lot_s = 0.0;
		}
		if ( LastStopLoss > 0 && count_s >= MaxTrades )
		{
			if ( NormalizeDouble( Ask - level_s - LastStopLoss*_Point, _Digits ) >= 0.0 )
			{
				Print( "LastStopLoss for SELL!" );
				if ( !CloseAll( OP_SELL ) ) return(-1);
				max_lot_s = 0.0;
			}
		}
	}

	// check fo open
	if ( TradeDirection >= 0 && count_b < MaxTrades )
	{
		if ( count_b == 0 )
		{
			if ( Close[1] >= Close[2] && Time[0] > last_b )
			{
				OpenBuy( StartLot );
//				last_b = Time[0];
			}
		}
		else
		{
			if ( level_b - PipStep*Point >= Ask ) OpenBuy( LotExponent*max_lot_b );
		}
	}
	if ( TradeDirection <= 0 && count_s < MaxTrades )
	{
		if ( count_s == 0 )
		{
			if ( Close[1] <= Close[2] && Time[0] > last_s )
			{
				OpenSell( StartLot );
//				last_s = Time[0];
			}
		}
		else
		{
			if ( level_s + PipStep*Point <= Bid ) OpenSell( LotExponent*max_lot_s );
		}
	}

	return(0);
}

void OpenBuy( double Lot )
{
	double _OpenPriceLevel, _StopLossLevel = 0.0, _TakeProfitLevel = 0.0;
	_OpenPriceLevel = NormalizeDouble( Ask, _Digits );
	_TakeProfitLevel = 0.0; //NormalizeDouble( Ask + (TakeProfit + 25)*_Point, _Digits );

	double 	lot_min		= MarketInfo( _Symbol, MODE_MINLOT  );
	double 	lot_max		= MarketInfo( _Symbol, MODE_MAXLOT  );
	double 	lot_step		= MarketInfo( _Symbol, MODE_LOTSTEP );

	Lot = NormalizeDouble( Lot / lot_step, 0 ) * lot_step;
	if ( Lot < lot_min ) Lot = lot_min;
	if ( Lot > lot_max ) Lot = lot_max;

	double needmargin = AccountFreeMarginCheck( Symbol(), OP_BUY, Lot );

	if ( needmargin < 5 || GetLastError() == 134 )
	{
		Print( "We have no money!!!" );
		return(-1);
	}

	if ( _OrderSend ( _Symbol, OP_BUY, Lot, _OpenPriceLevel, Slippage, _StopLossLevel, _TakeProfitLevel, "", _MagicNumber ) < 0 )
		Alert( strComment, ":    BUY-!!!" );
}

void OpenSell( double Lot )
{
	double _OpenPriceLevel, _StopLossLevel = 0.0, _TakeProfitLevel = 0.0;
	_OpenPriceLevel = NormalizeDouble( Bid, _Digits );
	_TakeProfitLevel = 0.0; //NormalizeDouble( Bid - (TakeProfit + 25)*_Point, _Digits );

	double 	lot_min		= MarketInfo( _Symbol, MODE_MINLOT  );
	double 	lot_max		= MarketInfo( _Symbol, MODE_MAXLOT  );
	double 	lot_step		= MarketInfo( _Symbol, MODE_LOTSTEP );

	Lot = NormalizeDouble( Lot / lot_step, 0 ) * lot_step;
	if ( Lot < lot_min ) Lot = lot_min;
	if ( Lot > lot_max ) Lot = lot_max;

	double needmargin = AccountFreeMarginCheck( Symbol(), OP_SELL, Lot );

	if ( needmargin < 5 || GetLastError() == 134 )
	{
		Print( "We have no money!!!" );
		return(-1);
	}

	if ( _OrderSend ( _Symbol, OP_SELL, Lot, _OpenPriceLevel, Slippage, _StopLossLevel, _TakeProfitLevel, "", _MagicNumber ) < 0 )
		Alert( strComment, ":    SELL-!!!" );
}

bool CloseAll( int type = -1 )
{
	bool result = true;
	int _GetLastError, _OrdersTotal = OrdersTotal();
	for ( int z = _OrdersTotal - 1; z >= 0; z -- )
	{
		if ( !OrderSelect( z, SELECT_BY_POS, MODE_TRADES ) )
		{
			_GetLastError = GetLastError();
			Print( "OrderSelect( ", z, ", SELECT_BY_POS, MODE_TRADES ) - Error #", _GetLastError );
			result = false;
			continue;
		}
		if ( OrderMagicNumber() != _MagicNumber || OrderSymbol() != _Symbol ) continue;
		if ( OrderType() > 1 ) continue;
		if ( type >= 0 && OrderType() != type ) continue;

		if ( _OrderClose( OrderTicket() ) < 0 ) result = false;
	}
	return(result);
}